/*
    *******************************************************
    * "De Delphi  C# avec BDS 2006"  ISBN 2-212-11768-X  *
    *******************************************************
    *                                                     *
    * Code source correspond aux exemples traits dans l' *
    * ouvrage.                                            *
    *                                                     *
    * Environment : Borland Developer Studio 2006         *
    * Test sur la version Architecte Franaise patch 1   *
    *                                                     *
    * Copyright   : Olivier Dahan                         *
    *                                                     *
    * Aucune copie, distribution, publication sans l'     *
    * accord exprs de l'auteur.                          *
    * Le prsent code source est fourni "tel quel"       *
    * titre d'illustration des propos techniques du livre *
    * Aucune garantie de fonctionnement ou d'adaptation   *
    * n'est fournie, aucune maintenance corrective ou     *
    * volutive ne sera fournie sur le prsent code.      *
    * Vous utilisez ce code sous votre seule responsabi-  *
    * lit et  vos risques et prils. L'auteur ne serait *
    * tre tenu pour responsable d'ventuelles pertes de  *
    * donnes ou de jouissance qui pourraient rsulter de *
    * l'utilisation du prsent code.                      *
    *                                                     *
    * Contact          : BDSLivre@e-naxos.com             *
    * Site de l'auteur : http://www.e-naxos.com           *
    *******************************************************

*/



using System;
using System.Collections;
using System.ComponentModel;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Data;
using System.Windows.Forms;

namespace ODDemoCS
{
	public class ScrollingText : System.Windows.Forms.Control
	{
		private Color _Color1 = Color.Black;
		private Color _Color2 = Color.Aquamarine;

		protected Timer _Timer;
		protected string _Text = null;


		public ScrollingText()
		{
//			this.SetStyle(ControlStyles.UserPaint |
//						  ControlStyles.AllPaintingInWmPaint |
//						  ControlStyles.DoubleBuffer, true);

			_Timer = new Timer();

			_Timer.Interval = 200;
			_Timer.Enabled = false;
			_Timer.Tick += new EventHandler( ScrollText );
		}

		protected override void Dispose(bool disposing)
		{
         if (_Timer != null) _Timer.Dispose();
		 base.Dispose(disposing);
		}

		public Color FirstColor
		{
			get { return _Color1; }
			set
			{
				_Color1 = value;
				Invalidate();
			}
		}

		public Color SecondColor
		{
			get { return _Color2; }
			set
			{
				_Color2 = value;
				Invalidate();
			}
		}

		public int Interval
		{ get { return _Timer.Interval; }
		  set { _Timer.Interval = value; }
		}

		void ScrollText( object sender, EventArgs e )
		{
			if( _Text == null ) return;

			_Text = _Text.Substring( 1, _Text.Length-1 ) + _Text.Substring(0, 1 );

			Invalidate();
		}

		public Boolean Running
		{ get { return _Timer.Enabled; }
		  set { _Timer.Enabled = value; if (!value) Invalidate(); }
		}

		private Boolean _HighQuality;
		public Boolean HighQuality
		{get { return _HighQuality; }
		 set { _HighQuality = value; Invalidate(); }
		}

		protected override void OnTextChanged( EventArgs e )
		{
			Running = false;
			_Text = Text;
			Invalidate();
			base.OnTextChanged( e );
		}

		protected override void OnClick( EventArgs e )
		{
			_Timer.Enabled = !_Timer.Enabled;
			base.OnClick( e );
		}


		protected override void OnPaint( PaintEventArgs e )
		{
			Brush back = new SolidBrush(BackColor);
			e.Graphics.FillRectangle(back,this.ClientRectangle);
			if (_HighQuality) e.Graphics.SmoothingMode = SmoothingMode.HighQuality;
			Brush theBrush = new System.Drawing.Drawing2D.LinearGradientBrush( ClientRectangle, _Color1, _Color2, 10 );
			Font theFont = new Font( Font.Name, Convert.ToInt16(Height* 0.8), Font.Style, GraphicsUnit.Pixel );
			e.Graphics.DrawString( _Text, theFont, theBrush, 0, 0 );
			base.OnPaint (e);
			theBrush.Dispose();
			theFont.Dispose();
		}
	}
}
