/*
    *******************************************************
    * "De Delphi  C# avec BDS 2006"  ISBN 2-212-11768-X  *
    *******************************************************
    *                                                     *
    * Code source correspond aux exemples traits dans l' *
    * ouvrage.                                            *
    *                                                     *
    * Environment : Borland Developer Studio 2006         *
    * Test sur la version Architecte Franaise patch 1   *
    *                                                     *
    * Copyright   : Olivier Dahan                         *
    *                                                     *
    * Aucune copie, distribution, publication sans l'     *
    * accord exprs de l'auteur.                          *
    * Le prsent code source est fourni "tel quel"       *
    * titre d'illustration des propos techniques du livre *
    * Aucune garantie de fonctionnement ou d'adaptation   *
    * n'est fournie, aucune maintenance corrective ou     *
    * volutive ne sera fournie sur le prsent code.      *
    * Vous utilisez ce code sous votre seule responsabi-  *
    * lit et  vos risques et prils. L'auteur ne serait *
    * tre tenu pour responsable d'ventuelles pertes de  *
    * donnes ou de jouissance qui pourraient rsulter de *
    * l'utilisation du prsent code.                      *
    *                                                     *
    * Contact          : BDSLivre@e-naxos.com             *
    * Site de l'auteur : http://www.e-naxos.com           *
    *******************************************************

*/



using System;
using System.Collections;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Windows.Forms;

namespace OdLogin
{
	public class OnLoginEventArgs : EventArgs
	{
	 public string UserName;
	 public string Password;
	}

	public delegate void OnLoginEvent (object sender, OnLoginEventArgs e);

	[ToolboxBitmap(typeof(ODLogin),"OdLogin.ODLogin.bmp")]
	public class ODLogin : System.Windows.Forms.UserControl
	{
		private System.ComponentModel.Container components = null;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.TextBox textBox1;
		private System.Windows.Forms.TextBox textBox2;
		private System.Windows.Forms.Button btnCreateAccount;
		private System.Windows.Forms.Button btnValidate;

		private string _UserName;
		private string _Password;

		public ODLogin()
		{
			InitializeComponent();
		}

		protected override void Dispose(bool disposing)
		{
			if (disposing)
			{
				if (components != null)
					components.Dispose();
			}
			base.Dispose(disposing);
		}

		[Browsable(true)]
		public string UserName
		 { get { return _UserName; }
		   set { _UserName = value; textBox1.Text = value; }
		 }

		[Browsable(true)]
		public string Password
		{ get { return _Password; }
		  set { _Password = value; textBox2.Text = value; }
		}

		[Browsable(true)]
		public event OnLoginEvent ValidateInput;

		[Browsable(true)]
		public event OnLoginEvent CreateAccount;

		#region Component Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.label1 = new System.Windows.Forms.Label();
			this.label2 = new System.Windows.Forms.Label();
			this.textBox1 = new System.Windows.Forms.TextBox();
			this.textBox2 = new System.Windows.Forms.TextBox();
			this.btnCreateAccount = new System.Windows.Forms.Button();
			this.btnValidate = new System.Windows.Forms.Button();
			this.SuspendLayout();
			// 
			// label1
			// 
			this.label1.AutoSize = true;
			this.label1.Location = new System.Drawing.Point(9, 11);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(63, 16);
			this.label1.TabIndex = 0;
			this.label1.Text = "User name:";
			// 
			// label2
			// 
			this.label2.AutoSize = true;
			this.label2.Location = new System.Drawing.Point(9, 51);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(57, 16);
			this.label2.TabIndex = 1;
			this.label2.Text = "Password:";
			// 
			// textBox1
			// 
			this.textBox1.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.textBox1.Location = new System.Drawing.Point(89, 7);
			this.textBox1.Name = "textBox1";
			this.textBox1.Size = new System.Drawing.Size(112, 20);
			this.textBox1.TabIndex = 2;
			this.textBox1.Text = "";
			this.textBox1.TextChanged += new System.EventHandler(this.textBox1_TextChanged);
			// 
			// textBox2
			//
			this.textBox2.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.textBox2.Location = new System.Drawing.Point(89, 47);
			this.textBox2.Name = "textBox2";
			this.textBox2.PasswordChar = '*';
			this.textBox2.Size = new System.Drawing.Size(112, 20);
			this.textBox2.TabIndex = 3;
			this.textBox2.Text = "";
			this.textBox2.TextChanged += new System.EventHandler(this.textBox2_TextChanged);
			// 
			// btnCreateAccount
			// 
			this.btnCreateAccount.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
			this.btnCreateAccount.Location = new System.Drawing.Point(9, 83);
			this.btnCreateAccount.Name = "btnCreateAccount";
			this.btnCreateAccount.Size = new System.Drawing.Size(93, 23);
			this.btnCreateAccount.TabIndex = 4;
			this.btnCreateAccount.Text = "Create account";
			this.btnCreateAccount.Click += new System.EventHandler(this.btnCreateAccount_Click);
			// 
			// btnValidate
			// 
			this.btnValidate.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
			this.btnValidate.Location = new System.Drawing.Point(126, 83);
			this.btnValidate.Name = "btnValidate";
			this.btnValidate.TabIndex = 5;
			this.btnValidate.Text = "Enter !";
			this.btnValidate.Click += new System.EventHandler(this.btnValidate_Click);
			// 
			// UserControl
			// 
			this.Controls.Add(this.btnValidate);
			this.Controls.Add(this.btnCreateAccount);
			this.Controls.Add(this.textBox2);
			this.Controls.Add(this.textBox1);
			this.Controls.Add(this.label2);
			this.Controls.Add(this.label1);
			this.Name = "ODLogin";
			this.Size = new System.Drawing.Size(208, 112);
			this.ResumeLayout(false);
		}
		#endregion

		private void textBox1_TextChanged(object sender, System.EventArgs e)
		{
			_UserName = textBox1.Text;
		}

		private void textBox2_TextChanged(object sender, System.EventArgs e)
		{
			_Password = textBox2.Text;
		}

		private void btnValidate_Click(object sender, System.EventArgs e)
		{
			if (ValidateInput != null)
			{ OnLoginEventArgs ee = new OnLoginEventArgs();
			  ee.Password = _Password;
			  ee.UserName = _UserName;
			  ValidateInput(this,ee);
			}
		}

		private void btnCreateAccount_Click(object sender, System.EventArgs e)
		{
			if (CreateAccount != null)
			{ OnLoginEventArgs ee = new OnLoginEventArgs();
			  ee.Password = _Password;
			  ee.UserName = _UserName;
			  CreateAccount(this,ee);
			}
		}


	}
}
