{
    *******************************************************
    * "De Delphi  C# avec BDS 2006"  ISBN 2-212-11768-X  *
    *******************************************************
    *                                                     *
    * Code source correspond aux exemples traits dans l' *
    * ouvrage.                                            *
    *                                                     *
    * Environment : Borland Developer Studio 2006         *
    * Test sur la version Architecte Franaise patch 1   *
    *                                                     *
    * Copyright   : Olivier Dahan                         *
    *                                                     *
    * Aucune copie, distribution, publication sans l'     *
    * accord exprs de l'auteur.                          *
    * Le prsent code source est fourni "tel quel"       *
    * titre d'illustration des propos techniques du livre *
    * Aucune garantie de fonctionnement ou d'adaptation   *
    * n'est fournie, aucune maintenance corrective ou     *
    * volutive ne sera fournie sur le prsent code.      *
    * Vous utilisez ce code sous votre seule responsabi-  *
    * lit et  vos risques et prils. L'auteur ne serait *
    * tre tenu pour responsable d'ventuelles pertes de  *
    * donnes ou de jouissance qui pourraient rsulter de *
    * l'utilisation du prsent code.                      *
    *                                                     *
    * Contact          : BDSLivre@e-naxos.com             *
    * Site de l'auteur : http://www.e-naxos.com           *
    *******************************************************

}



unit od.demo.login;

interface

uses
  System.Drawing, System.Collections, System.ComponentModel,
  System.Windows.Forms, System.Data;

type
  [ToolboxItem(false)]
  OnLoginEventArgs = class (EventArgs)
    public
     UserName,Password:system.string;
   end;

  OnLoginEvent = procedure(sender:system.Object;e:OnLoginEventArgs) of object;

  TodLogin = class(System.Windows.Forms.UserControl)
  {$REGION 'Designer Managed Code'}
  strict private
    /// <summary>
    /// Required designer variable.
    /// </summary>
    Components: System.ComponentModel.Container;
    Label1: System.Windows.Forms.Label;
    Label2: System.Windows.Forms.Label;
    TextBox1: System.Windows.Forms.TextBox;
    TextBox2: System.Windows.Forms.TextBox;
    btnValidate: System.Windows.Forms.Button;
    btnCreateAccount: System.Windows.Forms.Button;
    /// <summary>
    /// Required method for Designer support - do not modify
    /// the contents of this method with the code editor.
    /// </summary>
    procedure InitializeComponent;
    procedure btnValidate_Click(sender: System.Object; e: System.EventArgs);
    procedure btnCreateAccount_Click(sender: System.Object; e: System.EventArgs);
    procedure TextBox1_TextChanged(sender: System.Object; e: System.EventArgs);
    procedure TextBox2_TextChanged(sender: System.Object; e: System.EventArgs);
  {$ENDREGION}
  strict protected
    _UserName : string;
    _Password : string;
    _OnValidate : OnLoginEvent;
    _OnCreate: OnLoginEvent;
    procedure Dispose(Disposing: Boolean); override;
  private
    { Private Declarations }
  public
    constructor Create;
    procedure set_Password(const Value: string);
    procedure set_UserName(const Value: string);
  published
   [Category('OD Login'),Description('Nom de l''utilisateur')]
   property UserName : string read _UserName write set_UserName;
   [Category('OD Login'),Description('Mot de passe')]
   property Password : string read _Password write set_Password;
   [Category('OD Login events'),Description('Dclench quand le login est valid')]
   property OnValidate : OnLoginEvent add _OnValidate remove _OnValidate;
   [Category('OD Login events'),Description('Dclench sur demande de cration de compte')]
   property OnCreateAccountRequest : OnLoginEvent add _OnCreate remove _OnCreate;
  end;

  [assembly: RuntimeRequiredAttribute(TypeOf(TodLogin))]

{$R od.demo.TodLogin.bmp }

implementation

uses
  System.Globalization;

{$AUTOBOX ON}

{$REGION 'Windows Form Designer generated code'}
/// <summary>
/// Required method for Designer support -- do not modify
/// the contents of this method with the code editor.
/// </summary>
procedure TodLogin.InitializeComponent;
begin
  Self.Label1 := System.Windows.Forms.Label.Create;
  Self.Label2 := System.Windows.Forms.Label.Create;
  Self.TextBox1 := System.Windows.Forms.TextBox.Create;
  Self.TextBox2 := System.Windows.Forms.TextBox.Create;
  Self.btnValidate := System.Windows.Forms.Button.Create;
  Self.btnCreateAccount := System.Windows.Forms.Button.Create;
  Self.SuspendLayout;
  // 
  // Label1
  // 
  Self.Label1.AutoSize := True;
  Self.Label1.Location := System.Drawing.Point.Create(5, 8);
  Self.Label1.Name := 'Label1';
  Self.Label1.Size := System.Drawing.Size.Create(61, 16);
  Self.Label1.TabIndex := 0;
  Self.Label1.Text := 'Utilisateur :';
  // 
  // Label2
  // 
  Self.Label2.AutoSize := True;
  Self.Label2.Location := System.Drawing.Point.Create(5, 40);
  Self.Label2.Name := 'Label2';
  Self.Label2.Size := System.Drawing.Size.Create(78, 16);
  Self.Label2.TabIndex := 1;
  Self.Label2.Text := 'Mot de passe :';
  // 
  // TextBox1
  // 
  Self.TextBox1.BorderStyle := System.Windows.Forms.BorderStyle.FixedSingle;
  Self.TextBox1.Location := System.Drawing.Point.Create(93, 4);
  Self.TextBox1.Name := 'TextBox1';
  Self.TextBox1.TabIndex := 2;
  Self.TextBox1.Text := '';
  Include(Self.TextBox1.TextChanged, Self.TextBox1_TextChanged);
  // 
  // TextBox2
  // 
  Self.TextBox2.BorderStyle := System.Windows.Forms.BorderStyle.FixedSingle;
  Self.TextBox2.Location := System.Drawing.Point.Create(93, 38);
  Self.TextBox2.Name := 'TextBox2';
  Self.TextBox2.PasswordChar := '*';
  Self.TextBox2.TabIndex := 3;
  Self.TextBox2.Text := '';
  Include(Self.TextBox2.TextChanged, Self.TextBox2_TextChanged);
  // 
  // btnValidate
  // 
  Self.btnValidate.FlatStyle := System.Windows.Forms.FlatStyle.Flat;
  Self.btnValidate.Location := System.Drawing.Point.Create(129, 72);
  Self.btnValidate.Name := 'btnValidate';
  Self.btnValidate.Size := System.Drawing.Size.Create(64, 23);
  Self.btnValidate.TabIndex := 4;
  Self.btnValidate.Text := 'Entrer !';
  Include(Self.btnValidate.Click, Self.btnValidate_Click);
  // 
  // btnCreateAccount
  // 
  Self.btnCreateAccount.FlatStyle := System.Windows.Forms.FlatStyle.Flat;
  Self.btnCreateAccount.Location := System.Drawing.Point.Create(5, 72);
  Self.btnCreateAccount.Name := 'btnCreateAccount';
  Self.btnCreateAccount.Size := System.Drawing.Size.Create(100, 23);
  Self.btnCreateAccount.TabIndex := 5;
  Self.btnCreateAccount.Text := 'Crer un compte';
  Include(Self.btnCreateAccount.Click, Self.btnCreateAccount_Click);
  // 
  // TodLogin
  // 
  Self.Controls.Add(Self.btnCreateAccount);
  Self.Controls.Add(Self.Label1);
  Self.Controls.Add(Self.TextBox2);
  Self.Controls.Add(Self.TextBox1);
  Self.Controls.Add(Self.Label2);
  Self.Controls.Add(Self.btnValidate);
  Self.Name := 'TodLogin';
  Self.Size := System.Drawing.Size.Create(198, 99);
  Self.ResumeLayout(False);
end;
{$ENDREGION}

constructor TodLogin.Create;
begin
  inherited Create;
  InitializeComponent;
  _Password := '';
  _UserName := '';
end;

procedure TodLogin.TextBox2_TextChanged(sender: System.Object; e: System.EventArgs);
begin
  _Password := textbox2.text.trim;
end;

procedure TodLogin.TextBox1_TextChanged(sender: System.Object; e: System.EventArgs);
begin
  _UserName := textbox1.Text.trim;
end;

procedure TodLogin.btnCreateAccount_Click(sender: System.Object; e: System.EventArgs);
var ee:OnloginEventArgs;
begin
  if assigned(_OnCreate) then
   begin
   ee:= OnLoginEventArgs.Create;
   ee.Password := textbox2.Text.trim;
   ee.UserName := textbox1.Text.Trim;
   _OnCreate(self,ee);
   end;
end;

procedure TodLogin.btnValidate_Click(sender: System.Object; e: System.EventArgs);
var ee:OnloginEventArgs;
begin
  if assigned(_OnValidate) then
   begin
   ee:= OnLoginEventArgs.Create;
   ee.Password := textbox2.Text.trim;
   ee.UserName := textbox1.Text.Trim;
   _OnValidate(self,ee);
   end;
end;

procedure TodLogin.Dispose(Disposing: Boolean);
begin
  if Disposing then
  begin
    if Components <> nil then
      Components.Dispose();
  end;
  inherited Dispose(Disposing);
end;

procedure TodLogin.set_Password(const Value: string);
begin
 if assigned(value) and (value<>_Password) then
  begin
   _Password := value.trim;
   textbox2.text := value;
  end;
end;

procedure TodLogin.set_UserName(const Value: string);
begin
 if assigned(value) and (value<>_UserName) then
  begin
  _UserName := value.trim;
  textbox1.Text := value;
 end;
end;

end.
